(document:surround "/std/frame")
(document:insert "/std/functions")

(document:envelop with-translation _ "alterator-net-general")

(define (prepare-text str)
  (string-quote (lambda (ch)
		  (case ch
		    ((#\,) (string #\newline))
		    (else (string ch))))
		str))

(define (update-net-general-light)
    (let ((data (woo-read-first "/net-general")))
      (dhcp state (woo-get-option data 'has_dhcp #f))
      (dhcp-dns state (woo-get-option data 'dns_auto #f))
      (dhcp-hostname state (woo-get-option data 'hostname_auto #f))

      (update-constraints "write" "/net-general")
      data))

(define (update-net-general)
  (let ((data (update-net-general-light)))
    (hostname text (woo-get-option data 'hostname))
    (search text (woo-get-option data 'search))
    (dns text (woo-get-option data 'dns))))

(define (write-net-general . args)
  (woo-catch/message
   (thunk
    (apply woo-write/constraints "/net-general"
           'hostname_auto (dhcp-hostname state)
           'dns_auto (dhcp-dns state)
           'hostname (hostname text)
           'dns (prepare-text (dns text))
           'search (prepare-text (search text))
           args)
    (and (global 'frame:next)
         (apply woo-write "/autoinstall/net-general"
                    'hostname_auto (dhcp-hostname state)
                    'dns_auto (dhcp-dns state)
                    'hostname (hostname text)
                    'dns (prepare-text (dns text))
                    'search (prepare-text (search text))
                    args)))))

;;;;;;;;;;;;;;;;;;;;;;;

;;hidden field
(document:id dhcp (checkbox "have dhcp" invisible inactive widget-name "has_dhcp"))


(document:id dhcp-hostname  (checkbox (_ "Get hostname from DHCP") widget-name "hostname_auto"))
(hbox (label (_ "Hostname")) (document:id hostname  (edit "" widget-name "hostname")))

(label "")

(groupbox ""
          (document:id dhcp-dns  (checkbox (_ "Get resolver configuration from DHCP")  widget-name "dns_auto"))
          (hbox 
                (vbox
                 (label (_ "Search Domains"))
                 (document:id search (textbox "" widget-name "search")))
                (vbox
                 (label (_ "Domain Name Servers (DNS)"))
                 (document:id dns (textbox "" widget-name "dns")))))

(spacer)
(or (global 'frame:next)
    (hbox (button (_ "Apply") (when clicked (write-net-general)))
          (button (_ "Quit" ) (when clicked (document:end)))))

;;;
(document:root (when loaded (update-net-general)))

;;;wizard connections
(frame:on-next (thunk (or (write-net-general 'restart #f) 'cancel)))
(frame:on-back (thunk (or (write-net-general 'restart #f) 'cancel)))

(and (global 'frame:auto-save)
     (cell-set! (global 'frame:auto-save) (thunk (write-net-general 'restart #f))))

(and (global 'frame:auto-load)
     (cell-set! (global 'frame:auto-load) update-net-general-light))
